;;; SPDX-License-Identifier: LGPL-3.0-or-later
;;; SPDX-FileCopyrightText: Copyright © 2021-2024 Tony Garnock-Jones <tonyg@leastfixedpoint.com>

#lang racket/base

(provide (except-out (all-from-out "actor.rkt") current-turn)
         (struct-out entity-ref)
         (all-from-out "syntax.rkt")
         (all-from-out "query.rkt")
         (all-from-out "service.rkt")
         (all-from-out "event-expander.rkt")
         (all-from-out "async.rkt")
         (all-from-out preserves)
         (all-from-out preserves-schema)

         assertion-struct
         message-struct

         :pattern)

(require "actor.rkt")
(require "entity-ref.rkt")
(require "syntax.rkt")
(require "query.rkt")
(require "service.rkt")
(require "event-expander.rkt")
(require "async.rkt")
(require preserves)
(require preserves-schema)

;; Thin veneers over `struct` for declaring intent.
(define-syntax-rule (assertion-struct item ...) (struct item ... #:prefab))
(define-syntax-rule (message-struct item ...) (struct item ... #:prefab))

(require (only-in "pattern.rkt" :pattern))

(module reader syntax/module-reader syndicate/lang)
